// This file is part of GHome Mover (http://www.brookepeig.com/ghomemover)
// GHome Mover was created by Daniel Brooke Peig (daniel@brookepeig.com, http://www.brookepeig.com)
//
//
//
//    GHome Mover is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    GHome Mover is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with GHome Mover; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//This is the "Console Version" of GHome Mover, it is usefull for scripts

// Some instructions about updating this application:
// Just copy the updated custom_func.c and cust_func.h from the Original
// GHomeMover version to the src directory of this version.

#include <stdio.h>
#include "custom_func.h"
#include <string.h>
#include <stdlib.h>

// Same as the "button  begin pressed" in the Original GHomeMover
int prog_execute(char *input_source_dir, char *input_dest_dir, char *input_source_user, char *input_dest_user, char *input_source_group, char *input_dest_group, int input_option0, int input_option1, int input_option2)
{

// Notice that my initialization values are very confortable
// I dont know why didnt used a define.
char current_dir[512];
char new_file_loc[512];

char source_dir[512];
char dest_dir[512];
char source_user[512];
char dest_user[512];
char source_group[512];
char dest_group[512];
char log_message[512];

int chown_check;
int string_check;
int smart_check;

int smart_check_result = 0;

char commando[1024];

FILE *current_file;
char fileline[256];

// Get the data from the fields into the arrays (safer)
strcpy(source_dir, input_source_dir);
strcpy(dest_dir, input_dest_dir);
strcpy(source_user, input_source_user);
strcpy(dest_user, input_dest_user);
strcpy(source_group, input_source_group);
strcpy(dest_group, input_dest_group);

chown_check = input_option0;
string_check = input_option1;
smart_check = input_option2;

// Verify if all the fields have been completed
printf("%s", ("Checking if all the fields are completed..."));

if (strlen(source_dir) == 0 || strlen(dest_dir) == 0 || strlen(source_user) == 0 || strlen(dest_user) == 0 || strlen(source_group) == 0 || strlen(dest_group) == 0)
{
 	printf("%s", ("FAILED\nProcess stopped."));
	return 1;
}

else
{
	printf("%s", ("OK\n"));
}

// Verify if the dirs exists
printf("%s", ("Checking if the source dir exists..."));

strcpy(commando, "cd ");
strcat(commando, source_dir);

if (system(commando) != 0)
{
 	printf("%s", ("FAILED\nProcess stopped."));
	return 1;
}

else
{
	printf("%s", ("OK\n"));
}

printf("%s", ("Checking if the destination dir exists..."));

strcpy(commando, "cd ");
strcat(commando, dest_dir);

if (system(commando) != 0)
{
	printf("%s", ("NO\nCreating the destination dir..."));
		
	strcpy(commando, "mkdir ");
	strcat(commando, dest_dir);
	
	if (system(commando) != 0)
	{
		printf("%s", ("FAILED\nProcess stopped."));
		return 1;
	}
	else
	{
		printf("%s", ("OK\n"));
	}
}
else
{
	printf("%s", ("OK\n"));
}

// Copies the files from a directory to another
printf("%s", ("Coping the files..."));

if (copy_files(source_dir, dest_dir) == 0)
{
	printf("%s", ("OK\n"));
}

else
{
	printf("%s", ("FAILED\nProcess stopped."));
	return 1;
}

// Creates a list of the contents in the dir
printf("%s", ("Indexing the files..."));

if (index_files(dest_dir) == 0)
{
	printf("%s", ("OK\n"));
}

else
{
	printf("%s", ("FAILED\nProcess stopped."));
	return 1;
}


// Opens file by file and changes it permissions and contents

printf("%s", ("Changing files...\n"));

// Open the index file and read line by line
strcpy(fileline,dest_dir);
strcat(fileline,"/ghm_dirlist.txt");
	
if ((current_file = fopen(fileline, "r")) == NULL)
	{
		printf("%s", ("FAILED\nProcess stopped."));
		return 1;
	}

strcpy(current_dir, dest_dir);

while (fgets(fileline, sizeof(fileline), current_file) != NULL) 
	{
	// Clears the newline character
	strcpy(fileline, replacestr(fileline,"\n",""));
	
		
	// Check if it is a dir
	if (strstr(fileline,":") != NULL)
		{
		strcpy(current_dir,replacestr(fileline,":",""));		
		}

	// Ignores directories, sym links, empty lines, and "ghm_dirlist.txt" files
	// and makes the appropriate changes to the other files		
	if (strstr(fileline,"/") == NULL && strstr(fileline,"@") == NULL && strstr(fileline,"ghm_dir_list.txt") == NULL && strlen(fileline) > 0)
	{
		// File location
		strcpy(new_file_loc, current_dir);
		strcat(new_file_loc, "/");
		strcat(new_file_loc, fileline);
		
		//Changes the file name
		if(string_check != 0 && strstr(fileline,source_user) != NULL)
		{
			if (search_replace_filename(fileline, current_dir, source_user, dest_user) != 0)
			{
				strcpy(log_message, new_file_loc);
				strcat(log_message, " RENAME FAILED\n");
			}
			else
			{
				strcpy(new_file_loc, current_dir);
				strcat(new_file_loc, "/");
				strcat(new_file_loc,replacestr(fileline,source_user,dest_user));		
			}
		}
		
		// Executes the SMART check on the file
		smart_check_result = smart_file_select(new_file_loc);
		
		//Changes the file contents (directory and user references)
		if(string_check != 0 && (smart_check_result == 0 || smart_check == 0))
		{
			if (search_replace_onfile(new_file_loc, source_dir, dest_dir) != 0 || search_replace_onfile(new_file_loc, source_user, dest_user) != 0)
			{
				strcpy(log_message, new_file_loc);
				strcat(log_message, " REPLACE REFERENCES FAILED\n");
			}
			else
			{
				strcpy(log_message, new_file_loc);
				strcat(log_message, " OK\n");
			}
		}
		
		// List files ignored by SMART
		if(string_check != 0 && smart_check_result != 0 && smart_check != 0)
		{
			strcpy(log_message, new_file_loc);
			strcat(log_message, " IGNORED BY SMART\n");
		}
		
	} // Close of the files action
		
	} // Close of the index loop
		
fclose(current_file);

printf("%s", ("Changing Files... OK\n"));
	
// Changes the OWNERS of the destination DIR
if (chown_check != 0)
{
printf("%s", ("Changing Owner..."));

	if(dir_chown(dest_dir, source_user, dest_user, source_group, dest_group) != 0)
	{
		printf("%s", ("FAILED\n"));
	}
	
	else
	{
		printf("%s", ("OK\n"));
	}
}

// Delete the file list index (it is not necessary to display any message).
strcpy(commando,"rm ");
strcat(commando, dest_dir);
strcat(commando, "/ghm_dirlist.txt");
printf("%s", ("Removing file index..."));

if (system(commando) == 0)
{
	printf("%s", ("OK\n"));
}

else
{
	printf("%s", ("FAILED\n"));
}

// Finished message
printf("%s", ("Process finished. See the log above for non critical errors.\n\n"));
return 0;	
}

// Main Function
int
main (int argc, char *argv[])
{
	
// Declare variables
char param1[500];
char param2[500];
char param3[500];
char param4[500];
char param5[500];
char param6[500];
int param7;
int param8;
int param9;
int i;

// Check for all the arguments
if (argc >= 6)
{
//Get the command line data and initialize variables
strcpy(param1,argv[1]); // Source dir
strcpy(param2,argv[2]); // Dest dir
strcpy(param3,argv[3]); // Source user
strcpy(param4,argv[4]); // Dest user
strcpy(param5,argv[5]); // Source group
strcpy(param6,argv[6]); // Dest group
param7= 1; // Chown
param8= 1; // Replace
param9= 1; // Smart

// Get the options
for (i=6;i<argc;i++)
{
	if(strstr(argv[i],"nochown") != NULL) param7=0;
	if(strstr(argv[i],"noreplace") != NULL) param8=0;
	if(strstr(argv[i],"nosmart") != NULL) param9=0;
}

// Print a welcome screen
printf("Welcome to the GHome Mover Console - Version 0.2\n");
printf("http://www.brookepeig.com/ghomemover\n");
printf("This application was developed by Daniel Brooke Peig (ghomemover@brookepeig.com)\n");
printf("and is distributed acording the GNU GPL License.\n");
printf("--------------------------------------------------------------------------------\n\n");

// Start the application and return 1 if it had a fatal error.
if((prog_execute(param1, param2, param3, param4, param5, param6, param7, param8, param9))!=0) return 1;	
}

// Display the HELP/ABOUT Contents
else
{
printf("Welcome to the GHome Mover Console - Version 0.2\n");
printf("http://www.brookepeig.com/ghomemover\n");
printf("This application was developed by Daniel Brooke Peig (ghomemover@brookepeig.com)\n");
printf("and is distributed acording the GNU GPL License.\n");
printf("--------------------------------------------------------------------------------\n");
printf("GHome mover is an application designed to copy (carbon-copy) a home Directory from a user to another.\n");
printf("This application also looks at the files for references to the old directory and replaces\n");
printf("with the references of the new dir. Ownership is also changed.\n");
printf("--------------------------------------------------------------------------------\n");
printf("Help and Usage Instructions (Recommended to be logged as a root user)\n\n");
printf("ghomemover_console SOURCE_DIR DEST_DIR SOURCE_USER DEST_USER SOURCE_GROUP DEST_GROUP [OPTIONS]\n\n");
printf("OPTIONS:\n");
printf("--nochown : Disable changing file and directory owners\n");
printf("--noreplace: Disable replacing references in the files\n");
printf("--nosmart: Disable SMART reference replacing (will look for references in all files):\n");
}

return (0);
}
